// Generated by CoffeeScript 1.11.1
var Mixer, binding, pcm, stream,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

binding = require('../build/Release/binding');

stream = require('stream');

pcm = require('./constants');

Mixer = (function(superClass) {
  extend(Mixer, superClass);

  function Mixer(channels, format) {
    var i, ref;
    this.channels = channels != null ? channels : 2;
    this.format = format != null ? format : pcm.FMT_F32LE;
    stream.Readable.call(this);
    this.alignment = pcm.ALIGNMENTS[this.format];
    this.mixer = new binding.Mixer(this.channels, this.alignment, this.format, (function(_this) {
      return function(err, chunk) {
        if (err != null) {
          throw err;
        }
        return _this.push(chunk);
      };
    })(this));
    this.bufferSize = this.mixer.samplesPerBuffer * this.alignment;
    this.inputs = (function() {
      var j, ref, results;
      results = [];
      for (i = j = 0, ref = this.channels; 0 <= ref ? j < ref : j > ref; i = 0 <= ref ? ++j : --j) {
        results.push((function(_this) {
          return function(i) {
            return (new stream.PassThrough).on('readable', function() {
              return _this.readInput(i);
            });
          };
        })(this)(i));
      }
      return results;
    }).call(this);
    if (this.channels === 1) {
      this.mono = this.inputs[0];
    }
    if (this.channels === 2) {
      ref = [this.inputs[0], this.inputs[1]], this.left = ref[0], this.right = ref[1];
    }
  }

  Mixer.prototype.readInput = function(channel) {
    var chunk;
    if (this.mixer.mixing || this.mixer.channelsReady[channel]) {
      return false;
    }
    chunk = this.inputs[channel].read(this.bufferSize);
    if (chunk == null) {
      return false;
    }
    if (chunk.length > this.bufferSize) {
      this.inputs[channel].unshift(chunk.slice(this.bufferSize, chunk.length));
      chunk = chunk.slice(0, this.bufferSize);
    }
    return this.mixer.write(channel, chunk);
  };

  Mixer.prototype._read = function(size) {
    var i, j, ref;
    for (i = j = 0, ref = this.channels; 0 <= ref ? j < ref : j > ref; i = 0 <= ref ? ++j : --j) {
      this.readInput(i);
    }
    return this.push('');
  };

  return Mixer;

})(stream.Readable);

module.exports = Mixer;
